'use strict';

/* jshint ignore:start */
/**
 * This code was generated by
 * \ / _    _  _|   _  _
 *  | (_)\/(_)(_|\/| |(/_  v1.0.0
 *       /       /
 */
/* jshint ignore:end */

var _ = require('lodash');  /* jshint ignore:line */
var AuthRegistrationsCredentialListMappingList = require(
    './authRegistrationsMapping/authRegistrationsCredentialListMapping').AuthRegistrationsCredentialListMappingList;

var AuthTypeRegistrationsList;

/* jshint ignore:start */
/**
 * @description Initialize the AuthTypeRegistrationsList
 *
 * @param {Twilio.Api.V2010} version - Version of the resource
 * @param {string} accountSid - The unique id of the account that sent the call
 * @param {string} domainSid - A string that uniquely identifies the SIP Domain
 */
/* jshint ignore:end */
AuthTypeRegistrationsList = function AuthTypeRegistrationsList(version,
    accountSid, domainSid) {
  /* jshint ignore:start */
  /**
   * @param {string} sid - sid of instance
   *
   * @returns {Twilio.Api.V2010.AccountContext.SipContext.DomainContext.AuthTypesContext.AuthTypeRegistrationsContext}
   */
  /* jshint ignore:end */
  function AuthTypeRegistrationsListInstance(sid) {
    return AuthTypeRegistrationsListInstance.get(sid);
  }

  AuthTypeRegistrationsListInstance._version = version;
  // Path Solution
  AuthTypeRegistrationsListInstance._solution = {accountSid: accountSid, domainSid: domainSid};

  // Components
  AuthTypeRegistrationsListInstance._credentialListMappings = undefined;

  Object.defineProperty(AuthTypeRegistrationsListInstance,
    'credentialListMappings', {
    get: function credentialListMappings() {
      if (!this._credentialListMappings) {
        this._credentialListMappings = new AuthRegistrationsCredentialListMappingList(
          this._version,
          this._solution.accountSid,
          this._solution.domainSid
        );
      }

      return this._credentialListMappings;
    }
  });

  return AuthTypeRegistrationsListInstance;
};

module.exports = {
  AuthTypeRegistrationsList: AuthTypeRegistrationsList
};
