/**
 * This code was generated by
 * \ / _    _  _|   _  _
 *  | (_)\/(_)(_|\/| |(/_  v1.0.0
 *       /       /
 */

import Page = require('../../../../../../base/Page');
import Response = require('../../../../../../http/response');
import V1 = require('../../../../V1');
import serialize = require('../../../../../../base/serialize');
import { SerializableClass } from '../../../../../../interfaces';

type ChallengeChallengeReason = 'none'|'not_needed'|'not_requested';

type ChallengeChallengeStatus = 'pending'|'expired'|'approved'|'denied';

/**
 * @description Initialize the ChallengeList
 * PLEASE NOTE that this class contains preview products that are subject to change. Use them with caution. If you currently do not have developer preview access, please contact help@twilio.com.
 *
 * @param version - Version of the resource
 * @param serviceSid - Service Sid.
 * @param identity - Unique identity of the Entity
 * @param factorSid - Factor Sid.
 */
declare function ChallengeList(version: V1, serviceSid: string, identity: string, factorSid: string): ChallengeListInstance;

/**
 * Options to pass to update
 *
 * @property authPayload - Optional payload to verify the Challenge
 */
interface ChallengeInstanceUpdateOptions {
  authPayload?: string;
}

interface ChallengeListInstance {
  /**
   * @param sid - sid of instance
   */
  (sid: string): ChallengeContext;
  /**
   * create a ChallengeInstance
   *
   * @param opts - Options for request
   * @param callback - Callback to handle processed record
   */
  create(opts?: ChallengeListInstanceCreateOptions, callback?: (error: Error | null, item: ChallengeInstance) => any): Promise<ChallengeInstance>;
  /**
   * Constructs a challenge
   *
   * @param sid - A string that uniquely identifies this Challenge, or `latest`.
   */
  get(sid: string): ChallengeContext;
}

/**
 * Options to pass to create
 *
 * @property details - Public details provided to contextualize the Challenge
 * @property expirationDate - The future date in which this Challenge will expire
 * @property hiddenDetails - Hidden details provided to contextualize the Challenge
 */
interface ChallengeListInstanceCreateOptions {
  details?: string;
  expirationDate?: Date;
  hiddenDetails?: string;
}

interface ChallengePayload extends ChallengeResource, Page.TwilioResponsePayload {
}

interface ChallengeResource {
  account_sid: string;
  date_created: Date;
  date_responded: Date;
  date_updated: Date;
  details: string;
  entity_sid: string;
  expiration_date: Date;
  factor_sid: string;
  hidden_details: string;
  identity: string;
  reason: ChallengeChallengeReason;
  service_sid: string;
  sid: string;
  status: ChallengeChallengeStatus;
  type: string;
  url: string;
  verification_sid: string;
}

interface ChallengeSolution {
  factorSid?: string;
  identity?: string;
  serviceSid?: string;
}


declare class ChallengeContext {
  /**
   * Initialize the ChallengeContextPLEASE NOTE that this class contains preview products that are subject to change. Use them with caution. If you currently do not have developer preview access, please contact help@twilio.com.
   *
   * @param version - Version of the resource
   * @param serviceSid - Service Sid.
   * @param identity - Unique identity of the Entity
   * @param factorSid - Factor Sid.
   * @param sid - A string that uniquely identifies this Challenge, or `latest`.
   */
  constructor(version: V1, serviceSid: string, identity: string, factorSid: string, sid: string);

  /**
   * fetch a ChallengeInstance
   *
   * @param callback - Callback to handle processed record
   */
  fetch(callback?: (error: Error | null, items: ChallengeInstance) => any): Promise<ChallengeInstance>;
  /**
   * remove a ChallengeInstance
   *
   * @param callback - Callback to handle processed record
   */
  remove(callback?: (error: Error | null, items: ChallengeInstance) => any): void;
  /**
   * update a ChallengeInstance
   *
   * @param opts - Options for request
   * @param callback - Callback to handle processed record
   */
  update(opts?: ChallengeInstanceUpdateOptions, callback?: (error: Error | null, items: ChallengeInstance) => any): Promise<ChallengeInstance>;
}


declare class ChallengeInstance extends SerializableClass {
  /**
   * Initialize the ChallengeContextPLEASE NOTE that this class contains preview products that are subject to change. Use them with caution. If you currently do not have developer preview access, please contact help@twilio.com.
   *
   * @property sid - A string that uniquely identifies this Challenge.
   * @property accountSid - Account Sid.
   * @property serviceSid - Service Sid.
   * @property entitySid - Entity Sid.
   * @property identity - Unique identity of the Entity
   * @property factorSid - Factor Sid.
   * @property dateCreated - The date this Challenge was created
   * @property dateUpdated - The date this Challenge was updated
   * @property dateResponded - The date this Challenge was responded
   * @property expirationDate - The date this Challenge is expired
   * @property verificationSid - Verification Sid.
   * @property status - The Status of this Challenge
   * @property reason - The Reason of this Challenge `status`
   * @property details - Public details provided to contextualize the Challenge
   * @property hiddenDetails - Hidden details provided to contextualize the Challenge
   * @property type - The Factor Type of this Challenge
   * @property url - The URL of this resource.
   *
   * @param version - Version of the resource
   * @param payload - The instance payload
   * @param serviceSid - Service Sid.
   * @param identity - Unique identity of the Entity
   * @param factorSid - Factor Sid.
   * @param sid - A string that uniquely identifies this Challenge, or `latest`.
   */
  constructor(version: V1, payload: ChallengePayload, serviceSid: string, identity: string, factorSid: string, sid: string);

  private _proxy: ChallengeContext;
  accountSid: string;
  dateCreated: Date;
  dateResponded: Date;
  dateUpdated: Date;
  details: string;
  entitySid: string;
  expirationDate: Date;
  factorSid: string;
  /**
   * fetch a ChallengeInstance
   *
   * @param callback - Callback to handle processed record
   */
  fetch(callback?: (error: Error | null, items: ChallengeInstance) => any): void;
  hiddenDetails: string;
  identity: string;
  reason: ChallengeChallengeReason;
  /**
   * remove a ChallengeInstance
   *
   * @param callback - Callback to handle processed record
   */
  remove(callback?: (error: Error | null, items: ChallengeInstance) => any): void;
  serviceSid: string;
  sid: string;
  status: ChallengeChallengeStatus;
  /**
   * Produce a plain JSON object version of the ChallengeInstance for serialization.
   * Removes any circular references in the object.
   */
  toJSON(): any;
  type: string;
  /**
   * update a ChallengeInstance
   *
   * @param opts - Options for request
   * @param callback - Callback to handle processed record
   */
  update(opts?: ChallengeInstanceUpdateOptions, callback?: (error: Error | null, items: ChallengeInstance) => any): void;
  url: string;
  verificationSid: string;
}


declare class ChallengePage extends Page<V1, ChallengePayload, ChallengeResource, ChallengeInstance> {
  /**
   * Initialize the ChallengePagePLEASE NOTE that this class contains preview products that are subject to change. Use them with caution. If you currently do not have developer preview access, please contact help@twilio.com.
   *
   * @param version - Version of the resource
   * @param response - Response from the API
   * @param solution - Path solution
   */
  constructor(version: V1, response: Response<string>, solution: ChallengeSolution);

  /**
   * Build an instance of ChallengeInstance
   *
   * @param payload - Payload response from the API
   */
  getInstance(payload: ChallengePayload): ChallengeInstance;
}

export { ChallengeContext, ChallengeInstance, ChallengeList, ChallengeListInstance, ChallengeListInstanceCreateOptions, ChallengePage, ChallengePayload, ChallengeResource, ChallengeSolution }
