/**
 * This code was generated by
 * \ / _    _  _|   _  _
 *  | (_)\/(_)(_|\/| |(/_  v1.0.0
 *       /       /
 */

import BulkExports = require('../BulkExports');
import Page = require('../../../base/Page');
import Response = require('../../../http/response');
import serialize = require('../../../base/serialize');
import { SerializableClass } from '../../../interfaces';

/**
 * @description Initialize the ExportConfigurationList
 * PLEASE NOTE that this class contains preview products that are subject to change. Use them with caution. If you currently do not have developer preview access, please contact help@twilio.com.
 *
 * @param version - Version of the resource
 */
declare function ExportConfigurationList(version: BulkExports): ExportConfigurationListInstance;

/**
 * Options to pass to update
 *
 * @property enabled - The enabled
 * @property webhookMethod - The webhook_method
 * @property webhookUrl - The webhook_url
 */
interface ExportConfigurationInstanceUpdateOptions {
  enabled?: boolean;
  webhookMethod?: string;
  webhookUrl?: string;
}

interface ExportConfigurationListInstance {
  /**
   * @param sid - sid of instance
   */
  (sid: string): ExportConfigurationContext;
  /**
   * Constructs a export_configuration
   *
   * @param resourceType - The resource_type
   */
  get(resourceType: string): ExportConfigurationContext;
}

interface ExportConfigurationPayload extends ExportConfigurationResource, Page.TwilioResponsePayload {
}

interface ExportConfigurationResource {
  enabled: boolean;
  resource_type: string;
  url: string;
  webhook_method: string;
  webhook_url: string;
}

interface ExportConfigurationSolution {
}


declare class ExportConfigurationContext {
  /**
   * Initialize the ExportConfigurationContextPLEASE NOTE that this class contains preview products that are subject to change. Use them with caution. If you currently do not have developer preview access, please contact help@twilio.com.
   *
   * @param version - Version of the resource
   * @param resourceType - The resource_type
   */
  constructor(version: BulkExports, resourceType: string);

  /**
   * fetch a ExportConfigurationInstance
   *
   * @param callback - Callback to handle processed record
   */
  fetch(callback?: (error: Error | null, items: ExportConfigurationInstance) => any): Promise<ExportConfigurationInstance>;
  /**
   * update a ExportConfigurationInstance
   *
   * @param opts - Options for request
   * @param callback - Callback to handle processed record
   */
  update(opts?: ExportConfigurationInstanceUpdateOptions, callback?: (error: Error | null, items: ExportConfigurationInstance) => any): Promise<ExportConfigurationInstance>;
}


declare class ExportConfigurationInstance extends SerializableClass {
  /**
   * Initialize the ExportConfigurationContextPLEASE NOTE that this class contains preview products that are subject to change. Use them with caution. If you currently do not have developer preview access, please contact help@twilio.com.
   *
   * @property enabled - The enabled
   * @property webhookUrl - The webhook_url
   * @property webhookMethod - The webhook_method
   * @property resourceType - The resource_type
   * @property url - The url
   *
   * @param version - Version of the resource
   * @param payload - The instance payload
   * @param resourceType - The resource_type
   */
  constructor(version: BulkExports, payload: ExportConfigurationPayload, resourceType: string);

  private _proxy: ExportConfigurationContext;
  enabled: boolean;
  /**
   * fetch a ExportConfigurationInstance
   *
   * @param callback - Callback to handle processed record
   */
  fetch(callback?: (error: Error | null, items: ExportConfigurationInstance) => any): void;
  resourceType: string;
  /**
   * Produce a plain JSON object version of the ExportConfigurationInstance for serialization.
   * Removes any circular references in the object.
   */
  toJSON(): any;
  /**
   * update a ExportConfigurationInstance
   *
   * @param opts - Options for request
   * @param callback - Callback to handle processed record
   */
  update(opts?: ExportConfigurationInstanceUpdateOptions, callback?: (error: Error | null, items: ExportConfigurationInstance) => any): void;
  url: string;
  webhookMethod: string;
  webhookUrl: string;
}


declare class ExportConfigurationPage extends Page<BulkExports, ExportConfigurationPayload, ExportConfigurationResource, ExportConfigurationInstance> {
  /**
   * Initialize the ExportConfigurationPagePLEASE NOTE that this class contains preview products that are subject to change. Use them with caution. If you currently do not have developer preview access, please contact help@twilio.com.
   *
   * @param version - Version of the resource
   * @param response - Response from the API
   * @param solution - Path solution
   */
  constructor(version: BulkExports, response: Response<string>, solution: ExportConfigurationSolution);

  /**
   * Build an instance of ExportConfigurationInstance
   *
   * @param payload - Payload response from the API
   */
  getInstance(payload: ExportConfigurationPayload): ExportConfigurationInstance;
}

export { ExportConfigurationContext, ExportConfigurationInstance, ExportConfigurationList, ExportConfigurationListInstance, ExportConfigurationPage, ExportConfigurationPayload, ExportConfigurationResource, ExportConfigurationSolution }
