/**
 * This code was generated by
 * \ / _    _  _|   _  _
 *  | (_)\/(_)(_|\/| |(/_  v1.0.0
 *       /       /
 */

import Page = require('../../../../base/Page');
import Response = require('../../../../http/response');
import V2 = require('../../V2');
import { SerializableClass } from '../../../../interfaces';

/**
 * @description Initialize the NumberList
 *
 * @param version - Version of the resource
 */
declare function NumberList(version: V2): NumberListInstance;

/**
 * Options to pass to fetch
 *
 * @property originationNumber - The origination_number
 */
interface NumberInstanceFetchOptions {
  originationNumber?: string;
}

interface NumberListInstance {
  /**
   * @param sid - sid of instance
   */
  (sid: string): NumberContext;
  /**
   * Constructs a number
   *
   * @param destinationNumber - Fetches voice prices for number
   */
  get(destinationNumber: string): NumberContext;
}

interface NumberPayload extends NumberResource, Page.TwilioResponsePayload {
}

interface NumberResource {
  country: string;
  destination_number: string;
  inbound_call_price: string;
  iso_country: string;
  origination_number: string;
  outbound_call_prices: string;
  price_unit: string;
  url: string;
}

interface NumberSolution {
}


declare class NumberContext {
  /**
   * Initialize the NumberContext
   *
   * @param version - Version of the resource
   * @param destinationNumber - Fetches voice prices for number
   */
  constructor(version: V2, destinationNumber: string);

  /**
   * fetch a NumberInstance
   *
   * @param opts - Options for request
   * @param callback - Callback to handle processed record
   */
  fetch(opts?: NumberInstanceFetchOptions, callback?: (error: Error | null, items: NumberInstance) => any): Promise<NumberInstance>;
}


declare class NumberInstance extends SerializableClass {
  /**
   * Initialize the NumberContext
   *
   * @property destinationNumber - The destination phone number, in E.164
   * @property originationNumber - The origination phone number, in E.164
   * @property country - Name of the country
   * @property isoCountry - The ISO country code
   * @property outboundCallPrices - List of OutboundCallPriceWithOrigin records
   * @property inboundCallPrice - List of InboundCallPrice records
   * @property priceUnit - The currency in which prices are measured, in ISO 4127 format (e.g. usd, eur, jpy).
   * @property url - The URL of this resource.
   *
   * @param version - Version of the resource
   * @param payload - The instance payload
   * @param destinationNumber - Fetches voice prices for number
   */
  constructor(version: V2, payload: NumberPayload, destinationNumber: string);

  private _proxy: NumberContext;
  country: string;
  destinationNumber: string;
  /**
   * fetch a NumberInstance
   *
   * @param opts - Options for request
   * @param callback - Callback to handle processed record
   */
  fetch(opts?: NumberInstanceFetchOptions, callback?: (error: Error | null, items: NumberInstance) => any): void;
  inboundCallPrice: string;
  isoCountry: string;
  originationNumber: string;
  outboundCallPrices: string;
  priceUnit: string;
  /**
   * Produce a plain JSON object version of the NumberInstance for serialization.
   * Removes any circular references in the object.
   */
  toJSON(): any;
  url: string;
}


declare class NumberPage extends Page<V2, NumberPayload, NumberResource, NumberInstance> {
  /**
   * Initialize the NumberPage
   *
   * @param version - Version of the resource
   * @param response - Response from the API
   * @param solution - Path solution
   */
  constructor(version: V2, response: Response<string>, solution: NumberSolution);

  /**
   * Build an instance of NumberInstance
   *
   * @param payload - Payload response from the API
   */
  getInstance(payload: NumberPayload): NumberInstance;
}

export { NumberContext, NumberInstance, NumberList, NumberListInstance, NumberPage, NumberPayload, NumberResource, NumberSolution }
